;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Hhenanalysedaten abgekrzt HAYDN von DGMs bertragen                 ;;;
;;; Udo Hbner - fr Civil 3D 2007-2009                                   ;;;
;;; nicht untersttzt, wegen API Einschrnkungen werden Civil/MAP 2005-2006;;
;;; Neu    13.07.07 - V0.9                                                ;;;
;;; Update 26.07.07 - V1.0 Schreibfehler verbessert, sowie DWGPREFIX als  ;;;
;;;                   Pfadvorschlag hinzugefgt                           ;;;
;;; Update 02.08.07.  connecttocivil berarbeitet                         ;;;
;;;                   V1.1 - Auslieferungsstand zu Civil 3D 2009          ;;;
;;; Update 30.02.08   Anpassung an Civil 2009                             ;;;
;;;                   V1.2                                                ;;;
;;; Update 30.10.08   Fehler bei ElevationRegions bei flachen DGM abgef.  ;;;
;;; Update 04.11.08   Fehler bei tri. Mengen DGMS durch vorgeschaltete    ;;;
;;;                   Iteration durch die DGM Collection behoben          ;;;
;;; Update 08.11.08   Untersttzung von Raster DGMs                       ;;;
;;; Update 09.03.09   Anpassung an Civil 2010                             ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Routine zum bertragen von Hhenanalysedaten                          ;;;
;;; Exportieren von Hhenanalysedaten in eine Textdatei (Tab-delimited)   ;;;
;;; Importieren und Zuweisen von Hhenanalysedaten aus einer Textdatei    ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; getestet mit Civil 3D 2007, 2008 und 2009, 2010                       ;;;
;;; Aufruf: HAYDNTRANS  Hhenanalysedaten bertragen                      ;;;
;;;         HAYDNEXPORT HhenAnalysedatenexportieren und                  ;;;
;;;         HAYDNIMPORT HhenAnalysedatenimportieren                      ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Hinweis: True Color und Farbbuchfarben werden durch eine Indexfarbe   ;;;
;;; ersetzt.                                                              ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Untersttzung der Namen aus dem DACH Country Kit 2007-2009
(DEFUN C:HhenAnalysedatenimportieren ()
  (C:HAYDNIMPORT)(princ)
)
(DEFUN C:HhenAnalysedatenexportieren ()
  (C:HAYDNEXPORT)(princ)
)
(DEFUN C:HhenAnalysedatenbertragen ()
  (C:HAYDNTRANS)(princ)
)

(vl-load-com)
(defun connecttocivil (/ AeccObj aecstring)
  (setq aecstring
   (cond
    ;((= (atof (getvar "acadver")) 16.2) "AeccXUiLand.AeccApplication.3.0"); MAP/Civil 2006
    ((= (atof (getvar "acadver")) 17.0) "AeccXUiLand.AeccApplication.4.0"); Civil 2007
    ((= (atof (getvar "acadver")) 17.1) "AeccXUiLand.AeccApplication.5.0"); Civil 2008
    ((= (atof (getvar "acadver")) 17.2) "AeccXUiLand.AeccApplication.6.0"); Civil 2009
    ((= (atof (getvar "acadver")) 18.0) "AeccXUiLand.AeccApplication.7.0"); Civil 2010
    ((= (atof (getvar "acadver")) 18.1) "AeccXUiLand.AeccApplication.8.0"); Civil 2011
    ((= (atof (getvar "acadver")) 18.2) "AeccXUiLand.AeccApplication.9.0"); Civil 2012
    ;('T "AeccXUiLand.AeccApplication") ; Civil 
   )
  )
  (if
    (vl-catch-all-error-p
      (setq AeccObj
        (vl-catch-all-apply
          'vla-getinterfaceobject
          (list (vlax-get-acad-object) aecstring) ; connect to Civil 200x
        )
      )
    )
    NIL
    AeccObj
  )
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun C:HAYDNTRANS ( / ALLREGIONS AECCOBJ CNT TinEntity SSDGMS )
  (Prompt "\nDGM-Analysedaten bertragen V1.2 - www.CAD-Huebner.de")
  (if (not (setq AeccObj (connecttocivil)))
    (progn
      (prompt "\nCivil 3D steht nicht zur Verfgung - Programm abgebrochen!")
      (exit)
    )
  )
  ;;; wegen BUG in Civil 2009 die Analysefunktionen einmal initialisieren
  (if (not *HAYDNalreadyinUse*)(progn (getTinTypes)(setq *HAYDNalreadyinUse* 'T)))  
  (If (and (setq TinEntity (car (entsel "\nQuell-DGM whlen:")))
           (member  (cdr (assoc 0 (entget TinEntity)))
                    '("AECC_TIN_SURFACE" "AECC_GRID_SURFACE"))
      )
    (if (Setq AllRegions (GETTINDATA TinEntity))
      (progn
        (prompt "Ziel-DGMs whlen:")
        (if (setq ssDGMS (SSGET (list (cons 0 "AECC_*_SURFACE"))))
          (progn
            (setq cnt (sslength ssDGMS))
            (while (>= (setq cnt (1- cnt)) 0)
              (PutTINDATA (ssname ssDGMs cnt)  AllRegions)
            )
          )
        )
      )
      ;else
      (Prompt "\nDGM enthlt keine bertragbaren Analysedaten.")
    )
    (Prompt "\nKein DGM gewhlt.")
  )
  (prin1)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; EXPORT VON HHENANALYSEDATEN IN TAB GETRENNTE TEXTDATEI               ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun C:HAYDNEXPORT ( / allRegions cnt datei dimz file region regiondata
                         TinEntity )
  (Prompt "\nDGM-Analysedaten exportieren V1.2 - www.CAD-Huebner.de")
   ;;; wegen BUG in Civil 2009 die Analysefunktionen einmal initialisieren
  (if (not *HAYDNalreadyinUse*)(progn (getTinTypes)(setq *HAYDNalreadyinUse* 'T)))
  (if (and (setq TinEntity (car (entsel "\nQuell-DGM whlen:")))
           (member  (cdr (assoc 0 (entget TinEntity)))
                    '("AECC_TIN_SURFACE" "AECC_GRID_SURFACE"))
           (setq datei (getfiled "Exportdatei fr DGM-Analysedaten angeben:"
                                 (strcat (getvar "dwgprefix")(getvar "dwgname"))
                                 "txt"
                                 1
                       )
           )
      )
    (progn
      (setq file (open datei "w"))
      (Write-line "Farbnummer\tMin. Hhe\tMax. Hhe" file)
      ; Daten mssen mit Nachkommastellen exportiert werden
      (setq dimz (getvar "dimzin"))
      (setvar "dimzin" 2)
      (foreach region (setq regiondata (GETTINDATA TinEntity))
        (write-line (strcat (itoa (car   region))     "\t" ; Color
                            (rtos (cadr  region) 2 3) "\t" ; MinimumElevation
                            (rtos (caddr region) 2 3)      ; MaximumElevation
                    )
                    file
        )
      )
      (setvar "dimzin" dimz)
      (close file)
      (if (not regiondata)
        (prompt "\ndas DGM enthlt keine Analysedaten!")
        (prompt "Ausgabe beendet.")
      )
    )
    (Prompt "\nKein DGM gewhlt.")
  )
  (prin1)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; IMPORT VON HHENANALYSEDATEN AUS TAB GETRENNTER TEXTDATEI             ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun C:HAYDNIMPORT ( / AeccObj allRegions cnt Datei  
		         File Region Zeile TinEntity
		     )
  (Prompt "\nDGM-Analysedaten importieren und zuweisen V1.2 - www.CAD-Huebner.de")
  (if (not (Setq AeccObj (connecttoCivil)))
    (progn
      (prompt "Civil 3D 20XX nicht verfgbar, Programm abgebrochen!")
      (exit)
    )
  )
  ;;; wegen BUG in Civil 2009 die Analysefunktionen einmal initialisieren
  (if (not *HAYDNalreadyinUse*)
    (progn
      (getTinTypes)
      (setq *HAYDNalreadyinUse* 'T)
    )
  )
    
  (if (and (setq TinEntity (car (entsel "\nZiel-DGM whlen:")))
           (member  (cdr (assoc 0 (entget TinEntity)))
                    '("AECC_TIN_SURFACE" "AECC_GRID_SURFACE"))
           (setq datei (getfiled "Importdatei fr DGM-Analysedaten angeben:"
                                 (strcat (getvar "dwgprefix")(getvar "dwgname"))
                                 "txt"
                                 0
                       )
           )
      )
    (progn
      (setq file (open datei "r"))
      (read-line file)
      (while (setq zeile (read-line file))
        (setq region (read (strcat "(" zeile ")"))
              allRegions (cons region allRegions)
        )
      )
      (close file)
      (if (RegionDataok? (reverse AllRegions))
        (PutTINDATA TinEntity  (reverse AllRegions))
        (alert "Datei enthlt ungltige Datenstze!\nImport fehlgeschlagen.")
      )
      (prompt "fertig.")

    )
    (Prompt "\nKein DGM gewhlt.")
  )
  (prin1)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; PRFUNG, OB BEREICHSTABELLEN IN TEXTDATEI DEN BEDINGUNGEN DER         ;;;
;;; ElevationRegions ENTSPRECHEN, MINIMUM MUSS KLEINER GLEICH MAXIMUM     ;;;
;;; UND DIE HHENBEREICHE DRFEN SICH NICHT BERSCHNEIDEN                 ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun RegionDataok? (AllRegions / cnt ok )
  ; einfache  Validierung der Regionenwerte aus der Textdatei
  (setq cnt 0
        ok  'T
  )
  (repeat (length allRegions)
    (if (> (cadr (nth cnt allRegions)) (caddr (nth cnt allRegions)))
      (progn
         (Prompt (strcat "\nProblem: Datensatz in Zeile "
                         (itoa (1+ cnt)) " ungltig! Min > Max."))
         (setq ok nil)
      )
    )
    (Cond
      ((= cnt 0) 'T)
      ((= (cadr (nth cnt allRegions)) (caddr (nth (1- cnt) allRegions))) 'T)
      ((> (cadr (nth cnt allRegions)) (caddr (nth (1- cnt) allRegions)))
       (Prompt (strcat "\nHinweis: Lcke bei Datensatz in Zeile " (itoa (1+ cnt))
                       "  Max < Min Folgezeile."))
      )
      ((< (cadr (nth cnt allRegions)) (caddr (nth (1- cnt) allRegions)))
       (Prompt (strcat "\nProblem: berschneidung bei Datensatz in Zeile "
                       (itoa (1+ cnt)) "  Max > Min Folgezeile."))
       (setq ok nil)
      )
      ('T 'T)
    )
    (Setq cnt (1+ cnt))
  )
  (if (not allRegions) nil ok); leere Liste verursacht Fehler, ansonsten Rckgabewert
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; GETTINDATA - GIBT DIE HHENANALYSEDATEN ALS LISTE ZURCK              ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun GETTINDATA (TinEntity /
                   AllRegions DGMOBJECT ELEVATIONREGIONS REGIONLIST
                   SURFACEANALYSIS SURFACEANALYSISELEVATION )
  (setq DGMObject (vlax-ename->vla-object TinEntity)
        SurfaceAnalysis (vlax-get-property DGMObject "SurfaceAnalysis")
        SurfaceAnalysisElevation (vlax-get-property SurfaceAnalysis "ElevationAnalysis")
        ElevationRegions (vlax-get-property SurfaceAnalysisElevation "ElevationRegions")
  )	
  (vlax-for Region ElevationRegions
    (setq Regionlist (list (vlax-get-property Region "Color")
                           (vlax-get-property Region "MinimumElevation")
                           (vlax-get-property Region "MaximumElevation")
                     )
          AllRegions (cons Regionlist AllRegions)
    )
    ; example / Beispiel
    ;   Color = 26
    ;   MaximumElevation = 80.0
    ;   MinimumElevation = 60.0
  )
  (reverse allRegions)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; PUTTINDATA - SCHREIBT DIE ALS LISTE BERGEBENEN HHENANALYSEDATEN AN  ;;;
;;; DAS AUSGEWHLTE DGM                                                   ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun PUTTINDATA (TinEntity Regions
                   / cntrecreatedRegions dgmObject elevationregions SurfaceAnalysis
                   Surfaceanalysiselevation RegionObjlist tempmax )
  (setq DGMObject (vlax-ename->vla-object TinEntity)
        SurfaceAnalysis (vlax-get-property DGMObject "SurfaceAnalysis")
        SurfaceAnalysisElevation (vlax-get-property SurfaceAnalysis "ElevationAnalysis")
  )
  ; die Methode verursacht mitunter "unbekannte Fehler", deshalb Fehler abfangen
  (if (vl-catch-all-error-p
      (setq ElevationRegions
        (vl-catch-all-apply
          'vlax-invoke-method
          (list SurfaceAnalysisElevation
                "CalculateElevationRegions"
                (length Regions)
                :vlax-true ; Skalierung nach Farbschema
          )
        )
      )   
    )
    (Prompt "\nDaten konnten nicht zugwiesen werden!")
    ; Problem knnte z.B. ein nicht verfgbares Farbschema sein. 
    (progn
      ;;; da die Bereiche sich nicht berlagern drfen, werden Sie temporr
      ;;; mit werten auserhalb des Zielbereichs neu belegt,
      ;;; dann erst mit den endgltigen Realwerten belegt.
      ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;;; Aufgrund eines BUGs bei flachen DGMs hier noch mal prfen, ob
      ;;; die Anzahl der Regionen mit (length Regions) bereinstimmt
      (setq cntrecreatedRegions 0)  
      ;;; zuerst eine Objektliste erzeugen
      (vlax-for Region ElevationRegions
        (setq regionobjlist (cons Region Regionobjlist) 
              cntrecreatedRegions (1+ cntrecreatedRegions)
        )
      )
      (if (/= cntrecreatedRegions (length Regions))
        (Prompt (Strcat "\nAnzahl erzeugter Regionen <" (itoa cntrecreatedRegions)
                        ">, Soll war <" (itoa (length Regions)) ">. "))
      )
      (if (> cntrecreatedRegions 0)
        (progn
          (Setq tempmax (+ (last (last Regions))
                           (vlax-get-property (car regionobjlist) "MaximumElevation" )
                           (length Regions)
                        )
          )
          (foreach Region regionobjlist
            (vlax-put-property Region "MaximumElevation" tempmax)
            (vlax-put-property Region "MinimumElevation" (setq Tempmax (1- tempmax)))
            )
          (foreach Region (reverse regionobjlist)
            (if (caar Regions)
              (progn
                (vlax-put-property Region "Color" (caar Regions))
                (vlax-put-property Region "MinimumElevation" (cadar Regions))
                (vlax-put-property Region "MaximumElevation" (caddar Regions))
                (setq Regions (cdr Regions))
              )
            )
          )
        )
      )
    )
  )  
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; LISTE DER 4 DGM-Typen zurckgeben (TIN, MENGEN TIN,                   ;;;
;;; RASTER und MENGEN RASTER)                                             ;;;
;;; Durch einmaligen Zugriff wird der BUG beim Zugriff auf die            ;;;
;;; Analysedaten bei Mengen TINs behoben                                  ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(DEFUN getTinTypes ( / AeccApp AeccDoc AeccSurfaces cnt dgm Tinlist)
  ;;; Auflisten der DGM Typen
  ;;; durch den ActiveX Zugriff auf alle DGMs werden Probleme beim Zugriff
  ;;; auf Analysedaten bei triangulierten Mengenmodellen vermieden.
  (if (setq aeccApp (connecttocivil))
    (progn
      (setq aeccDoc (vlax-get aeccApp "activedocument"))
      (setq aeccSurfaces (vlax-get-property aeccDoc "Surfaces"))
      
      (setq cnt (vlax-get-property aeccSurfaces "count"))
      (while (>= (setq cnt (1- cnt)) 0)
        (setq TinList
               (cons
                 (list (vlax-get-property (setq dgm (vlax-get-property aeccSurfaces "item" cnt)) "name")
                       (vlax-get-property (setq dgm (vlax-get-property aeccSurfaces "item" cnt)) "Type")
                 )
                 tinList
               )
        )
        ;; Typ 4 =  Tin Volumen (trianguliertes Mengenmodell)
        ;; ((= 4 (vlax-get-property (setq dgm (vlax-get-property aeccSurfaces 'item cnt)) "Type"))
        ;; (setq stat (vlax-get-property dgm 'Statistics))
        ;; (Print (vlax-get-property (vlax-get-property stat 'BottomSurface) 'name))
        ;; (Print (vlax-get-property (vlax-get-property stat 'TopSurface) 'name))
      )
    )
    ; else
    NIL ; Civil/Map 3D nicht verfgbar - Programmausfhrung nicht mglich.
  )    
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(prompt (strcat "HAYDN.lsp geladen. Befehle\n"
                "HAYDNTRANS  Hhenanalysedaten bertragen\n"
                "HAYDNEXPORT Hhenanalysedaten exportieren und\n"
                "HAYDNIMPORT Hhenanalysedaten importieren stehen zur Verfgung."))
(princ)